class BookableSpaceModel {
  final String uuid;
  final String spaceName;
  final String virtualLocation;
  final BookableConfig bookableConfig;

  BookableSpaceModel({
    required this.uuid,
    required this.spaceName,
    required this.virtualLocation,
    required this.bookableConfig,
  });

  factory BookableSpaceModel.fromJson(Map<String, dynamic> json) {
    return BookableSpaceModel(
      uuid: json['uuid'] as String,
      spaceName: json['spaceName'] as String,
      virtualLocation: json['virtualLocation'] as String,
      bookableConfig: BookableConfig.fromJson(
          json['bookableConfig'] as Map<String, dynamic>),
    );
  }
}

class BookableConfig {
  final String uuid;
  final List<String> daysAvailable;
  final String startTime;
  final String endTime;
  final bool active;
  final int points;

  BookableConfig({
    required this.uuid,
    required this.daysAvailable,
    required this.startTime,
    required this.endTime,
    required this.active,
    required this.points,
  });

  factory BookableConfig.fromJson(Map<String, dynamic> json) {
    return BookableConfig(
      uuid: json['uuid'] as String,
      daysAvailable: (json['daysAvailable'] as List).cast<String>(),
      startTime: json['startTime'] as String,
      endTime: json['endTime'] as String,
      active: json['active'] as bool,
      points: json['points'] as int,
    );
  }
}