

import 'package:syncrow_web/pages/access_management/booking_system/domain/models/bookable_room.dart';

class PaginatedBookableSpaces {
  final List<BookableSpaceModel> data;
  final String message;
  final int page;
  final int size;
  final int totalItem;
  final int totalPage;
  final bool hasNext;
  final bool hasPrevious;

  PaginatedBookableSpaces({
    required this.data,
    required this.message,
    required this.page,
    required this.size,
    required this.totalItem,
    required this.totalPage,
    required this.hasNext,
    required this.hasPrevious,
  });

  factory PaginatedBookableSpaces.fromJson(Map<String, dynamic> json) {
    return PaginatedBookableSpaces(
      data: (json['data'] as List)
          .map((item) => BookableSpaceModel.fromJson(item))
          .toList(),
      message: json['message'] as String,
      page: json['page'] as int,
      size: json['size'] as int,
      totalItem: json['totalItem'] as int,
      totalPage: json['totalPage'] as int,
      hasNext: json['hasNext'] as bool,
      hasPrevious: json['hasPrevious'] as bool,
    );
  }
}