import 'package:bloc/bloc.dart';
import 'package:syncrow_web/pages/access_management/booking_system/presentation/bloc/date_selection/date_selection_event.dart';
import 'date_selection_state.dart';

class DateSelectionBloc extends Bloc<DateSelectionEvent, DateSelectionState> {
  DateSelectionBloc() : super(DateSelectionState.initial()) {
    on<SelectDate>((event, emit) {
      final newWeekStart = _getStartOfWeek(event.selectedDate);
      emit(DateSelectionState(
        selectedDate: event.selectedDate,
        weekStart: newWeekStart,
      ));
    });

    on<NextWeek>((event, emit) {
      final newWeekStart = state.weekStart.add(const Duration(days: 7));
      final inNewWeek = state.selectedDate
              .isAfter(newWeekStart.subtract(const Duration(days: 1))) &&
          state.selectedDate
              .isBefore(newWeekStart.add(const Duration(days: 7)));
      emit(DateSelectionState(
        selectedDate: state.selectedDate,
        weekStart: newWeekStart,
      ));
    });
    on<PreviousWeek>((event, emit) {
      emit(DateSelectionState(
        selectedDate: state.selectedDate!.subtract(const Duration(days: 7)),
        weekStart: state.weekStart.subtract(const Duration(days: 7)),
      ));
    });
  }

  static DateTime _getStartOfWeek(DateTime date) {
    return date.subtract(Duration(days: date.weekday - 1));
  }
}
