class DateSelectionState {
  final DateTime selectedDate;
  final DateTime weekStart;

  const DateSelectionState({
    required this.selectedDate,
    required this.weekStart,
  });

  factory DateSelectionState.initial() {
    final now = DateTime.now();
    return DateSelectionState(
      selectedDate: now,
      weekStart: _getStartOfWeek(now),
    );
  }

  static DateTime _getStartOfWeek(DateTime date) {
    return date.subtract(Duration(days: date.weekday - 1));
  }
}
