import 'package:syncrow_web/pages/access_management/booking_system/domain/models/bookable_room.dart';

class SidebarState {
  final List<BookableSpaceModel> allRooms;
  final List<BookableSpaceModel> displayedRooms;
  final bool isLoading;
  final bool isLoadingMore;
  final String? errorMessage;
  final String? selectedRoomId;
  final bool hasMore;
  final int totalPages;
  final int currentPage;

  SidebarState({
    required this.allRooms,
    required this.displayedRooms,
    required this.isLoading,
    this.isLoadingMore = false,
    this.errorMessage,
    this.selectedRoomId,
    this.hasMore = true,
    this.totalPages = 0,
    this.currentPage = 1,
  });

  SidebarState copyWith({
    List<BookableSpaceModel>? allRooms,
    List<BookableSpaceModel>? displayedRooms,
    bool? isLoading,
    bool? isLoadingMore,
    String? errorMessage,
    String? selectedRoomId,
    bool? hasMore,
    int? totalPages,
    int? currentPage,
  }) {
    return SidebarState(
      allRooms: allRooms ?? this.allRooms,
      displayedRooms: displayedRooms ?? this.displayedRooms,
      isLoading: isLoading ?? this.isLoading,
      isLoadingMore: isLoadingMore ?? this.isLoadingMore,
      errorMessage: errorMessage ?? this.errorMessage,
      selectedRoomId: selectedRoomId ?? this.selectedRoomId,
      hasMore: hasMore ?? this.hasMore,
      totalPages: totalPages ?? this.totalPages,
      currentPage: currentPage ?? this.currentPage,
    );
  }
}
