import 'package:flutter/material.dart';
import 'package:syncrow_web/pages/access_management/booking_system/domain/models/bookable_room.dart';
import 'package:syncrow_web/utils/color_manager.dart';

class RoomListItem extends StatelessWidget {
  final BookableSpaceModel room;
  final bool isSelected;
  final VoidCallback onTap;

  const RoomListItem({
    required this.room,
    required this.isSelected,
    required this.onTap,
  });

  @override
  Widget build(BuildContext context) {
    return RadioListTile(
      value: room.uuid,
      contentPadding: const EdgeInsetsDirectional.symmetric(horizontal: 16),
      groupValue: isSelected ? room.uuid : null,
      visualDensity: const VisualDensity(vertical: -4),
      onChanged: (value) => onTap(),
      activeColor: ColorsManager.primaryColor,
      title: Text(
        room.spaceName,
        style: Theme.of(context).textTheme.bodyMedium?.copyWith(
            color: ColorsManager.lightGrayColor,
            fontWeight: FontWeight.w700,
            fontSize: 12),
      ),
      subtitle: Text(
        room.virtualLocation,
        style: Theme.of(context).textTheme.bodySmall?.copyWith(
              fontSize: 10,
              fontWeight: FontWeight.w400,
              color: ColorsManager.textGray,
            ),
      ),
    );
  }
}
